package com.plannaplan.services;

import com.plannaplan.models.ConfigData;
import com.plannaplan.models.FileData;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.plannaplan.configutils.*;
import com.plannaplan.entities.AppConfig;

/**
 * FileReader is used for reading xls file from input stream.
 */
@Component
public class ConfiguratorService {

    @Autowired
    private FileToDatabaseMigrator migrator;
    @Autowired
    private AppConfigService configService;

    public ConfiguratorService() {
    }

    /**
     * methoid to config system
     * 
     * @param data ConfigData containng system congis
     */
    public void config(ConfigData data) {
        FileReader reader = new FileReader(data.getFilestream());
        FileData coursesData = reader.read();
        this.configService.save(new AppConfig(data.getFirstTour(), data.getSecondTour()));
        migrator.migrate(coursesData);
    }

}